<!DOCTYPE html>
<html>
	<head>
		<title></title>
		<link rel="stylesheet" href="/stylesheets/search-api.component.css" />
		<link
			href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.1/dist/css/bootstrap.min.css"
			rel="stylesheet"
			integrity="sha384-+0n0xVW2eSR5OomGNYDnhzAbDsOXxcvSN1TPprVMTNDbiYZCxYbOOl7+AMvyTG2x"
			crossorigin="anonymous"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script
			src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.1/dist/js/bootstrap.bundle.min.js"
			integrity="sha384-gtEjrD/SeCtmISkJkNUaaKMoLD0//ElJ19smozuHV6z3Iehds+3Ulb9Bn9Plx0x4"
			crossorigin="anonymous"
		></script>
	</head>

	<script>
		function getRandomColor(type = "light") {
			let lightColors = [
				"lightskyblue",
				"lightgreen",
				"lightpink",
				"lightcoral",
				"lightsalmon",
				"slateblue",
				"orange",
				"lightseagreen",
				"lightblue",
				"lightcyan",
				"lightsteelblue",
				"lightyellow",
				"lightslategray",
				"lightgoldenrodyellow"
			];

			let darkColors = [
				"blue",
				"green",
				"pink",
				"coral",
				"salmon",
				"slateblue",
				"orange",
				"seagreen",
				"blue",
				"steelblue",
				"black"
			];
			if (type === "light") return lightColors[Math.floor(Math.random() * lightColors.length)];
			return darkColors[Math.floor(Math.random() * darkColors.length)];
		}

		function highlightKeys(text, arr = []) {
			console.log("inside highlight", text, arr);
			if (arr.length === 0) {
				let t = [];
				arr = text.split(",");
				for (let i = 0; i < arr.length; i++) {
					t.push(
						`<mark style='background-color:transparent !important; color: ${getRandomColor("dark")} !important'>${
							arr[i]
						}</mark>`
					);
				}

				text = t.join(", ");
			} else {
				for (let i = 0; i < arr.length; i++) {
					let regex = new RegExp(arr[i], "ig");
					// console.log(regex, arr[i]);
					text = text.replace(regex, `<mark style='background-color: ${getRandomColor()}'>${arr[i]}</mark>`);
				}
			}
			// console.log(text);
			return text.toLowerCase();
		}

		function onSubmit(e) {
			if ((e && e.keyCode == 13) || e == 0) {
				console.log("enter pressed", e.target.value);
				e.preventDefault();

				// TODO: check for Checked facet_type

				let types = getSelectedCheckboxValues("facet_type");
				console.log(types);

				if (e.target.value != "") {
					$.ajax({
						url: "/esdata/api/v1/querySearch",
						cache: false,
						beforeSend: function () {
							// $("#image").show();
							console.log("beforeSend");
						},
						success: function (data) {
							// $(".info").append(html);
							console.log("success");
							$(".search-results").html(data.cards);
						},
						complete: function () {
							// $("#image").hide();
							console.log("complete");
						}
					});
				}
			}
		}

		// $(document).ready(function () {
		// 	$("form").on("submit", function (e) {
		// 		//ajax call here
		// 		console.log("applyfilters");
		// 	});
		// });

		function getSelectedCheckboxValues(name) {
			const checkboxes = document.querySelectorAll(`input[name="${name}"]:checked`);
			let values = [];
			checkboxes.forEach((checkbox) => {
				values.push(checkbox.value);
			});
			return values;
		}
	</script>

	<body>
		<!-- Main Page -->

		<div class="m-2 bg-light search-page">
			<div class="row bg-white justify-content-center" style="margin-bottom: 10px">
				<!-- LogoUrl -->

				<div class="col-3 nav-logo cur-point" onclick="navigateHome()">
					<img src="https://avaamo-demo-asset.s3.ap-south-1.amazonaws.com/public/images/oie_png.png" alt="Logo" />
					<img
						src="https://avaamo-demo-asset.s3.ap-south-1.amazonaws.com/public/images/Ericsson-logo.jpeg"
						alt="Logo"
					/>
					<div class="logo-title" style="display: inline-block; font-size: 15px; font-weight: bold">
						<p>Global Search Tool</p>
					</div>
				</div>

				<!-- End LogoUrl -->

				<!-- search input -->
				<div class="input-group col search-box">
					<div class="bg-light search-bar-group text-primary w-100">
						<div class="search-icon cur-point" onclick="onSubmit()">
							<svg
								xmlns="http://www.w3.org/2000/svg"
								width="1.3em"
								height="1.3em"
								viewBox="0 0 15 15"
								fill="currentColor"
							>
								<path
									d="M11.7384 10.4878C12.5756 9.39024 13.0814 8.01394 13.0814 6.5331C13.0814 2.92683 10.1512 0 6.5407 0C2.93023 0 0 2.92683 0 6.5331C0 10.1394 2.93023 13.0662 6.5407 13.0662C8.02326 13.0662 9.40116 12.561 10.5 11.7247L13.5174 14.7387C13.6919 14.9129 13.9186 15 14.1279 15C14.3372 15 14.5814 14.9129 14.7384 14.7387C15.0872 14.3902 15.0872 13.8502 14.7384 13.5017L11.7384 10.4878ZM6.5407 11.324C3.88953 11.324 1.74419 9.16376 1.74419 6.5331C1.74419 3.90244 3.88953 1.74216 6.5407 1.74216C9.19186 1.74216 11.3372 3.88502 11.3372 6.5331C11.3372 9.18118 9.17442 11.324 6.5407 11.324Z"
								/>
							</svg>
						</div>

						<div class="search-input">
							<input
								id="searchInput"
								type="text"
								placeholder="What are you looking for?"
								class="text-dark w-100 search-input-text-box"
								[formControl]="searchQuery"
								[ngbTypeahead]="typeahead"
								onkeypress="onSubmit(event)"
								(focus)="onSearchInputFocus($event)"
							/>
						</div>
					</div>
				</div>

				<!-- End search input-->
			</div>

			<div class="container">
				<div class="row bg-grey justify-content-center">
					<!-- Search Results-->
					<div class="col-3 m-2 filter-section">
						<p>Filter Section</p>

						<div class="form-check">
							<input class="form-check-input" type="checkbox" name="facet_type" value="article" id="article" />
							<label class="form-check-label" for="article">Article </label>
						</div>
						<div class="form-check">
							<input class="form-check-input" type="checkbox" name="facet_type" value="document" id="document" />
							<label class="form-check-label" for="document"> Document </label>
						</div>
						<div class="form-check">
							<input class="form-check-input" type="checkbox" name="facet_type" value="product" id="product" />
							<label class="form-check-label" for="product"> Product </label>
						</div>
						<button class="btn btn-outline-secondary btn-sm m-3 apply-filter">Apply Filter</button>

						<!-- <input class="btn btn-outline-secondary btn-sm" type="submit" value="Apply Filter" /> -->
					</div>
					<div class="col m-2 search-results">
						<!-- Cards  -->
						<%- cards %>
					</div>
				</div>
			</div>
		</div>
		<!-- End Main Page -->
	</body>
</html>
